#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: ngamsPostMortem.py,v 1.1 2005/09/02 10:31:03 jknudstr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  30/08/2005  Created
#

"""
Implements the NG/AMS Server Post Mortem Script.

The purpose of this script is to ensure that there is cleaned up after the
server terminates.

Specifically now, it is ensured that all NGAS Data Volumes are unmounted.
"""

import sys

from ngams import *
import ngamsDb, ngamsConfig


if __name__ == '__main__':
    """
    Main program.
    """
    cfgFile = sys.argv[2]
    if (len(sys.argv) >= 5):
        cfgDbId = sys.argv[4]
    else:
        cfgDbId = ""
    cfgObj = ngamsConfig.ngamsConfig().load(cfgFile)
    if ((cfgDbId != "None") and (cfgDbId != "")):
        dbCon = ngamsDb.ngamsDb(cfgObj.getDbServer(), cfgObj.getDbName(),
                                cfgObj.getDbUser(), cfgObj.getDbPassword(),
                                cfgObj.getDbSnapshot(),
                                cfgObj.getDbInterface())
        cfgObj.loadFromDb(cfgDbId, dbCon)
    mtRootPt = cfgObj.getMountRootDirectory()
    import ngamsLinuxSystemPlugInApi
    ngamsLinuxSystemPlugInApi.umount(mtRootPt)

# EOF
