#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: ngamsOnlineCmd.py,v 1.4 2004/08/04 16:45:30 ngasmgr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  13/05/2005  Created
#

"""
Function + code to handle the ONLINE command.
"""

from ngams import *
import ngamsSrvUtils


def handleCmdOnline(srvObj,
                    reqPropsObj,
                    httpRef):
    """
    Handle an ONLINE command.
        
    srvObj:         Reference to NG/AMS server class object (ngamsServer).
    
    reqPropsObj:    Request Property object to keep track of
                    actions done during the request handling
                    (ngamsReqProps).
        
    httpRef:        Reference to the HTTP request handler
                    object (ngamsHttpRequestHandler).

    Returns:        Void.
    """
    srvObj.checkSetState("Command ONLINE", [NGAMS_OFFLINE_STATE],
                         [NGAMS_IDLE_SUBSTATE])
    ngamsSrvUtils.handleOnline(srvObj, reqPropsObj)
    srvObj.reply(reqPropsObj.setCompletionTime(), httpRef, NGAMS_HTTP_SUCCESS,
                 NGAMS_SUCCESS, "Successfully handled command ONLINE")
    srvObj.updateRequestDb(reqPropsObj)
    info(1,"Successfully handled command ONLINE!")


# EOF
