#!/usr/bin/python
#******************************************************************************
# ESO/DMD
#
# "@(#) $Id: vultur_dot_util.py,v 1.1.1.1 2005/12/08 16:38:31 jknudstr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  15/04/2005  Created
#

import sys, os, time, commands
from vultur_utils import *


def correctUsage():
    """
    """
    #print "\nCorrect usage is:\n\n" +\
    #      "vultur_exec_cascade -jobId <ID> -jobs <Job List File>\n\n"
    pass


def convertIds(dotFile,
               outDotFile):
    """
    """
    # Load original DOT File.
    fo = open(dotFile)
    lines = fo.readlines()
    fo.close()

    # Convert the IDs.
    newDotFile = ""
    idDic = {}
    jobCount = 0
    for line in lines:
        if ((line.find("[") != -1) and (line.find("]") != -1)):
            id, body = line.split(" [")
            jobCount += 1
            idDic[id.strip()] = jobCount
            newDotFile += "    %s [%s" % (jobCount, body)
        elif (line.find(" -> ") != -1):
            id1, id2 = line.split(" -> ")
            jobCount1 = idDic[id1.strip()]
            jobCount2 = idDic[id2.strip()[:-1]]
            newDotFile += "    %s -> %s;\n" % (jobCount1, jobCount2)
        else:
            newDotFile += line

    # Write the converted DOT.
    os.system("rm -f %s" % outDotFile)
    fo = open(outDotFile, "w")
    fo.write(newDotFile)
    fo.close()


def procDot(argv):
    """
    """
    dot = outDot = None
    convert = 0
    idx = 1
    while idx < len(sys.argv):
        par = sys.argv[idx].upper()
        if (par == "-DOT"):
            idx += 1
            dot = sys.argv[idx].strip()
        elif (par == "-OUTDOT"):
            idx += 1
            outDot = sys.argv[idx].strip()
        elif (par == "-CONVERTIDS"):
            convert = 1
        elif ((par == "-H") or (par == "-HELP")):
            correctUsage()
            sys.exit(0)
        else:
            correctUsage()
            sys.exit(1)
        idx += 1

    if ((not dot) or (not outDot)):
        correctUsage()
        sys.exit(1)

    # Execute command.
    if (convert):
        convertIds(dot, outDot)
    else:
        pass


if __name__ == '__main__':
    """
    Main function.
    """
    procDot(sys.argv)
    sys.exit(0)

# EOF
