#!/usr/bin/python
#******************************************************************************
# ESO/DMD
#
# "@(#) $Id: vultur_exec_esorex_dfo.py,v 1.1.1.1 2005/12/08 16:38:31 jknudstr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  01/04/2005  Created
#

import sys, os, time, commands


# The Installation Root under which all the needed SW is found:
INST_ROOT = "/shared/system/i86/RH9.0/instroot"


def correctUsage():
    """
    """
    print "\nCorrect usage is:\n\n" +\
          "vultur_exec_esorex_dfo <ESOREX Paramaters> "+\
          "-user <User> [-instRoot <Installation Root>]\n\n"
    

def invokeEsorex(argv):
    """
    """
    user = None
    instRoot = INST_ROOT
    idx = 1
    esorexPars = ""
    while idx < len(sys.argv):
        par = sys.argv[idx].upper()
        if (par == "-USER"):
            idx += 1
            user = sys.argv[idx]
        elif (par == "-INSTROOT"):
            idx += 1
            instRoot = sys.argv[idx]
        elif ((par == "-H") or (par == "-HELP")):
            correctUsage()
            sys.exit(0)
        else:
            esorexPars += " " + sys.argv[idx]
        idx += 1
    
    if (not user):
        correctUsage()
        sys.exit(1)
    
    # Execute esorex.
    soDirs   = "%s/lib:%s/plugins" % (instRoot, instRoot)
    recDir   = instRoot + "/plugins"
    prodDir  = "/shared/data/%s/products" % user
    esoRexCmdFormat = "export LD_LIBRARY_PATH=%s; %s/bin/esorex " +\
                      "--recipe-dir=%s %s"
    esoRexCmd = esoRexCmdFormat % (soDirs, instRoot, recDir, esorexPars)
    try:
        print "Invoking esorex: %s" % esoRexCmd
        stat, out = commands.getstatusoutput(esoRexCmd)
        if (stat != 0):
            sys.stderr.write(out)
            sys.exit(1)
        else:
            print out
    except Exception, e:
        sys.stderr.write("\nProblem occurred executing esorex: %s\n" % str(e))
        sys.exit(1)

    
if __name__ == '__main__':
    """
    Main function.
    """
    invokeEsorex(sys.argv)
    sys.exit(0)

# EOF
