#!/usr/bin/python
#******************************************************************************
# ESO/DMD
#
# "@(#) $Id: vultur_utils.py,v 1.2 2006/03/08 14:46:08 jknudstr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  01/04/2005  Created
#

import sys, os, time, commands

# Handle BQSROOT.
if (not os.environ.has_key("BQSROOT")):
    #os.environ["BQSROOT"] = ""
    raise Exception, "Environment variable BQSROOT is not defined!"


# Job submission templates.
JOB_SUBM_FORM_SINGLE_JOB = """\
universe              = vanilla
executable            = %s%s
output                = %s/%s.out
error                 = %s/%s.err
log                   = %s/%s.log
arguments             = %s
#requirements         = (Could be supported)
should_transfer_files = NO
initialdir            = %s
notification          = NEVER
queue
"""

JOB_SUBM_FORM_MULT_JOBS = """\
universe              = vanilla
executable            = %s%s
output                = %s/%s_$(Process).out
error                 = %s/%s_$(Process).err
log                   = %s/%s_$(Process).log
arguments             = %s
#requirements         = (Could be supported)
should_transfer_files = NO
initialdir            = %s
notification          = NEVER
queue %d
"""


def info(msg):
    """
    """
    print "INFO> %s" % msg


def error(msg):
    """
    """
    print "ERROR> %s" % msg
 
 
def genJobSubmission(jobId,
                     user,
                     application,
                     args,
                     noOfJobs,
                     jobBaseDir,
                     jobWorkDir):
    """
    """
    jobSubmisName = os.path.normpath("%s/%s.cmd" % (jobBaseDir, jobId))
    outFile = errFile = logFile = os.path.normpath(jobBaseDir)
    if (application[0] == "/"):
        execRoot = ""
    else:
        execRoot = os.environ["INSTROOT"] + "/bin/"
    if (noOfJobs == 1):
        jobSubmis = JOB_SUBM_FORM_SINGLE_JOB % (execRoot,
                                                application,
                                                outFile, jobId,
                                                errFile, jobId,
                                                logFile, jobId,
                                                args, jobWorkDir)
    else:        
        jobSubmis = JOB_SUBM_FORM_MULT_JOBS % (execRoot,
                                               application,
                                               outFile, jobId,
                                               errFile, jobId,
                                               logFile, jobId,
                                               args, jobWorkDir,
                                               noOfJobs)
    os.system("rm -f %s" % jobSubmisName)
    fo = open(jobSubmisName, "w")
    fo.write(jobSubmis)
    fo.close()
    return jobSubmisName, jobSubmis


if __name__ == '__main__':
    """
    Main function.
    """
    sys.exit(0)

# EOF
